---
title: How to properly tag pages
slug: MDN/Contribute/Howto/Tag
tags:
  - Beginner
  - Contribute
  - Glossary
  - Guide
  - Howto
  - Intro
  - MDN Meta
  - Tutorial
---
<div>{{MDNSidebar}}</div>

<p class="summary"><strong>Article tags</strong> are an important way to put visitors in touch with helpful content. Each page should normally have several tags to help keep content organized. <span class="seoSummary">This page explains the best way to tag pages so that our readers can find information and we can keep ourselves organized.</span></p>

<p>For a help with the user interface for editing tags, see the <a href="/en-US/docs/MDN/Contribute/Editor/Basics#The_tags_box">tagging section</a> in our editor guide.</p>

<p>Please use tags properly as explained below. If you don't, our automated tools will not correctly generate lists of content, landing pages, and cross-linking of articles.</p>

<div class="notecard warning">
<p><strong>Note to translators and localizers:</strong> You should <em>not</em> translate any tags listed on this page. They are used for specific purposes such as certain site management tasks and automated data processing, and translating them would break these processes.</p>
</div>

<h2 id="How_MDN_uses_tags">How MDN uses tags</h2>

<p>Tags get used on MDN several ways:</p>

<dl>
 <dt>{{anch("Document category", "Document categorization")}}</dt>
 <dd>What type of document is it? Is it a reference? A tutorial? A landing page? Our visitors can use these tags to filter searches, so they're really important!</dd>
 <dt>{{anch("Topic", "Topic identification")}}</dt>
 <dd>What is the article about? Is it about an API? The DOM? Graphics? Again, these tags are important because they can filter searches.</dd>
 <dt>{{anch("API identification")}}</dt>
 <dd>Reference pages about an API need to identify the specific component of the API being documented (that is, what interface it's a part of, and what property or method the page covers, if applicable).</dd>
 <dt>{{anch("Technology status")}}</dt>
 <dd>What's the status of the technology? Is it non-standard? Obsolete or deprecated? Experimental?</dd>
 <dt>{{anch("Skill level")}}</dt>
 <dd>For tutorials and guides, how advanced is the material covered by the article?</dd>
 <dt>{{anch("Document metadata")}}</dt>
 <dd>The writing community uses tags to keep track of which pages need what kind of work.</dd>
</dl>

<h2 id="Tag_type_guide">Tag type guide</h2>

<p>Here's a quick guide to the types of tags and possible values for them.</p>

<h3 id="Document_category">Document category</h3>

<p>When you tag an article with one of these categories, you help the automated tools more accurately generate landing pages, tables of contents, and so on. Our new search system will also use these terms so that our visitors can locate reference or guide information at will.</p>

<p>We use the following category names as standard tagging terms:</p>

<dl>
 <dt><code>{{Tag("Intro")}}</code></dt>
 <dd>The article provides introductory material about a topic. Ideally each technology area should have only one "Intro"</dd>
 <dt><code>{{Tag("Reference")}}</code></dt>
 <dd>The article contains reference material about an API, element, attribute, property, or the like.</dd>
 <dt><code>{{Tag("Landing")}}</code></dt>
 <dd>The page is a landing page.</dd>
 <dt><code>{{Tag("Guide")}}</code></dt>
 <dd>The article is a how-to or guide page.</dd>
 <dt><code>{{Tag("Example")}}</code></dt>
 <dd>The article is a code sample page, or has code samples (that is, actual snippets of useful code, not one-line "syntax examples").</dd>
</dl>

<h3 id="Topic">Topic</h3>

<p>By identifying the article's topic area, you are helping generate better search results (and landing pages and navigation as well).</p>

<p>While there's some room for flexibility here as we identify new topic areas, we try to limit ourselves to the names of APIs or technologies. Some useful examples:</p>

<ul>
 <li><code>{{Tag("HTML")}}</code></li>
 <li><code>{{Tag("CSS")}}</code></li>
 <li><code>{{Tag("JavaScript")}}</code> (notice the capital "S"!)</li>
 <li><code>{{Tag("Document")}}</code></li>
 <li><code>{{Tag("DOM")}}</code></li>
 <li><code>{{Tag("API")}}</code> for each API's overview, interface, method, and property.</li>
 <li><code>{{Tag("Method")}}</code> for each method of an API</li>
 <li><code>{{Tag("Property")}}</code> for each property of an API</li>
 <li><code>{{Tag("Graphics")}}</code></li>
 <li><code>{{Tag("SVG")}}</code></li>
 <li><code>{{Tag("WebGL")}}</code></li>
 <li><code>{{Tag("Tools")}}</code></li>
 <li><code>{{Tag("Web")}}</code></li>
 <li><code>{{Tag("Element")}}</code></li>
 <li><code>{{Tag("Extensions")}}</code> and <code>{{Tag("WebExtensions")}}</code> for WebExtension documentation.</li>
</ul>

<p>In general, your topic identification tag should be the name of an interface with a number of related pages (like <a href="/en-US/docs/Web/API/Node">Node</a>, which has many pages for its various properties and methods), or the name of an overall technology type. You might tag a page about WebGL with <code>Graphics</code> and <code>WebGL</code>, for example, but a page about {{HTMLElement("canvas")}} with <code>HTML</code>, <code>Element</code>, <code>Canvas</code>, and <code>Graphics</code>.</p>

<h4 id="Mozilla-specific_content">Mozilla-specific content</h4>

<p>These tags are used in Mozilla-specific content only:</p>

<ul>
 <li><code>{{Tag("Mozilla")}}</code></li>
 <li><code>{{Tag("Firefox")}}</code></li>
 <li><code>{{Tag("Gecko")}}</code></li>
 <li><code>{{Tag("XUL")}}</code></li>
 <li><code>{{Tag("XPCOM")}}</code></li>
</ul>

<h3 id="API_identification">API identification</h3>

<p>Within the API reference, each article should identify which part of the API it covers:</p>

<dl>
 <dt><code>{{tag("Interface")}}</code></dt>
 <dd>The main article for an interface should have this tag. For example, {{DOMxRef("RTCPeerConnection")}}.</dd>
 <dt><code>{{tag("Constructor")}}</code></dt>
 <dd>Each interface may have up to one page tagged "Constructor"; this is the interface's constructor. The page should have the same name as the interface, like {{DOMxRef("RTCPeerConnection.RTCPeerConnection()", "RTCPeerConnection()")}}.</dd>
 <dt><code>{{tag("Property")}}</code></dt>
 <dd>Every article describing a particular property within an interface needs this tag. See {{DOMxRef("RTCPeerConnection.connectionState")}}, for example.</dd>
 <dt><code>{{tag("Method")}}</code></dt>
 <dd>Each article documenting an interface method needs this tag. See {{DOMxRef("RTCPeerConnection.createOffer()")}} for example.</dd>
</dl>

<p>In addition, the reference pages need to include interface, property, and method names among their tags. Some examples:</p>

<dl>
 <dt>The interface {{DOMxRef("RTCPeerConnection")}}</dt>
 <dd>Include the tag <code>{{Tag("RTCPeerConnection")}}</code> along with the other relevant tags (<code>{{Tag("Interface")}}</code>, <code>{{Tag("WebRTC")}}</code>, <code>{{Tag("WebRTC API")}}</code>, <code>{{Tag("API")}}</code>, <code>{{Tag("Reference")}}</code>, and so forth).</dd>
 <dt>The method {{DOMxRef("RTCPeerConnection.createOffer()")}}</dt>
 <dd>Include the tags <code>{{Tag("RTCPeerConnection")}}</code> and <code>{{Tag("createOffer")}}</code> (note <em>no</em> parentheses in tag names!) along with the other relevant tags, including <code>{{Tag("Method")}}</code>, <code>{{Tag("WebRTC")}}</code>, <code>{{Tag("WebRTC API")}}</code>, <code>{{Tag("API")}}</code>, <code>{{Tag("Reference")}}</code>, and so forth. Consider including things like <code>{{Tag("Offer")}}</code> and <code>{{Tag("SDP")}}</code>, which are also relevant here.</dd>
 <dt>The property {{DOMxRef("RTCPeerConnection.iceConnectionState")}}</dt>
 <dd>Include the tags <code>{{Tag("RTCPeerConnection")}}</code> and <code>{{Tag("iceConnectionState")}}</code> along with the other relevant tags, including <code>{{Tag("Property")}}</code>, <code>{{Tag("WebRTC")}}</code>, <code>{{Tag("WebRTC API")}}</code>, <code>{{Tag("API")}}</code> and <code>{{Tag("Reference")}}</code>. Also consider including <code>{{Tag("ICE")}}</code>.</dd>
</dl>

<h3 id="Technology_status">Technology status</h3>

<p>To help the reader understand how viable a technology is, we use tags to label pages as to the status of the technology's specification. This isn't as detailed as actually explaining what the spec is and how far the technology has come in the specification process (that's what the Specifications table is for), but it helps the reader judge, at a glance, whether it's a good idea to use the technology described in the article.</p>

<p>Here are possible values for these tags:</p>

<dl>
 <dt><code>{{Tag("Read-only")}}</code></dt>
 <dd>Apply this tag to reference pages which describe a property or attribute which is read-only.</dd>
 <dt><code>{{Tag("Non-standard")}}</code></dt>
 <dd>Indicates that the technology or API described on the page is not part of a standard, whether it's stable or not in any browsers which implement it (if it's not stable, it should also be {{Tag("Experimental")}}). If you don't use this tag, your readers will assume the technology is standard. The compatibility table on the page should clarify which browser(s) support this technology or API.</dd>
 <dt><code>{{Tag("Deprecated")}}</code></dt>
 <dd>The technology or API covered on the page is marked as deprecated in the specification, and is likely to eventually be removed, but is generally still available in current versions of browsers.</dd>
 <dt><code>{{Tag("Obsolete")}}</code></dt>
 <dd>The technology or API has been deemed obsolete and has been removed (or is actively being removed) from all or most current browsers.</dd>
 <dt><code>{{Tag("Experimental")}}</code></dt>
 <dd>The technology is not standardized, and is an experimental technology or API that may or may not ever become part of a standard. It is also subject to change in the browser engine (typically only one) that implements it. If the technology isn't part of any specification (even in draft form), it should also have the {{tag("Non-standard")}} tag.</dd>
 <dt><code>{{Tag("Needs Privileges")}}</code></dt>
 <dd>The API requires privileged access to the device on which the code is running.</dd>
 <dt><code>{{Tag("Certified Only")}}</code></dt>
 <dd>The API only works in certified code.</dd>
</dl>

<p>These tags are no excuse to leave out the <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables">compatibility table</a> in your article! That should always be present.</p>

<h3 id="Skill_level">Skill level</h3>

<p>Use the skill-level tag type only for guides and tutorials (that is, pages tagged <code>Guide</code>) to help users choose tutorials based on how familiar they are with a technology. There are three values for this:</p>

<dl>
 <dt><code>{{Tag("Beginner")}}</code></dt>
 <dd>Articles designed to introduce the reader to a technology they've never used or have only a passing familiarity with.</dd>
 <dt><code>{{Tag("Intermediate")}}</code></dt>
 <dd>Articles for users who have gotten started with the technology but aren't experts.</dd>
 <dt><code>{{Tag("Advanced")}}</code></dt>
 <dd>Articles about stretching the capabilities of a technology and of the reader.</dd>
</dl>

<h3 id="Document_metadata">Document metadata</h3>

<p>The writing community uses tags to label articles as requiring specific types of work. Here's a list of the ones we use most:</p>

<dl>
 <dt><code>{{Tag("Draft")}}</code></dt>
 <dd>The article is not complete, and is at least in theory still actively being updated (although it's also possible it's been forgotten about). Try to check with the most recent contributors before making changes, in order to avoid potential content collisions.</dd>
 <dt><code>{{Tag("NeedsCompatTable")}}</code></dt>
 <dd>The article needs a table to specify compatibility of a feature across browsers. <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables">See here</a> for a guide on contributing to browser compatibility.</dd>
 <dt><code>{{Tag("NeedsContent")}}</code></dt>
 <dd>The article is a stub, or is otherwise lacking information. This tag means that someone should review the content and add more details and/or finish writing the article.</dd>
 <dt><code>{{Tag("NeedsExample")}}</code></dt>
 <dd>The article needs one or more examples created to help illustrate the article's point. These examples should use the <a href="/en-US/docs/Project:MDN/Contributing/How_to_help/Code_samples">live sample system</a>.</dd>
 <dt><code>{{Tag("NeedsLiveSamples")}}</code></dt>
 <dd>The article has one or more examples that need to be updated to use the <a href="/en-US/docs/Project:MDN/Contributing/How_to_help/Code_samples">live sample system</a>.</dd>
 <dt><code>{{Tag("NeedsMarkupWork")}}</code></dt>
 <dd>The article needs improvement to the page markup (usually because the page content consists mostly or entirely of {{HTMLElement("p")}} tags).</dd>
 <dt><code>{{Tag("NeedsSpecTable")}}</code></dt>
 <dd>The article needs a table to indicate on which specification document(s) the feature was defined.</dd>
 <dt><code>{{Tag("NeedsUpdate")}}</code></dt>
 <dd>The content is out of date and needs to be updated.</dd>
 <dt><code>{{Tag("l10n:exclude")}}</code></dt>
 <dd>The content is not really worth localizing and will not appear on localization status pages.</dd>
 <dt><code>{{Tag("l10n:priority")}}</code></dt>
 <dd>The content is important and should be marked as a priority for MDN translators. Shows up in an extra priority table on localization status pages.</dd>
</dl>

<h2 id="Putting_it_all_together">Putting it all together</h2>

<p>So to each page you assign tags from several tag types, for example</p>

<dl>
 <dt>A tutorial about WebGL for beginners</dt>
 <dd>{{Tag("WebGL")}}, {{Tag("Graphics")}}, {{Tag("Guide")}}, {{Tag("Beginner")}}</dd>
 <dt>Reference page for {{HTMLElement("canvas")}}</dt>
 <dd>{{Tag("Canvas")}}, {{Tag("HTML")}}, {{Tag("Element")}}, {{Tag("Graphics")}}, {{Tag("Reference")}}</dd>
 <dt>A landing page for Firefox developer tools</dt>
 <dd>{{Tag("Tools")}}, {{Tag("Firefox")}}, {{Tag("Landing")}}</dd>
</dl>

<h2 id="Tagging_and_search_filters">Tagging and search filters</h2>

<p>Search filters won't work properly unless we tag MDN pages properly. Here's a table of search filters and which tags they look for. (Search filters are used only on the <a href="https://wiki.developer.mozilla.org">wiki</a> (editing) site; the <a href="https://developer.mozilla.org">read-only</a> site uses a different search system without filters.)</p>

<div class="notecard note">
<p><strong>Note:</strong> If multiple tags are listed under "Tag name," that means any one or more of these tags must be present for the article to match.</p>
</div>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Filter group</th>
   <th scope="col">Search filter name</th>
   <th scope="col">Tag name</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th rowspan="22" scope="row" style="vertical-align: baseline;">Topic</th>
   <td>APIs and DOM</td>
   <td>{{Tag("API")}} || {{Tag("DOM")}} {{Deprecated_Inline}}</td>
  </tr>
  <tr>
   <td>Add-ons &amp; Extensions {{Deprecated_Inline}}</td>
   <td>{{Tag("Add-ons")}} || {{Tag("Extensions")}} || {{Tag("Plugins")}} || {{Tag("Themes")}} || {{Tag("WebExtensions")}}</td>
  </tr>
  <tr>
   <td>CSS</td>
   <td>{{Tag("CSS")}}</td>
  </tr>
  <tr>
   <td>Canvas</td>
   <td>{{Tag("Canvas")}}</td>
  </tr>
  <tr>
   <td>Firefox</td>
   <td>{{Tag("Firefox")}}</td>
  </tr>
  <tr>
   <td>Firefox OS</td>
   <td>{{Tag("Firefox OS")}}</td>
  </tr>
  <tr>
   <td>Games</td>
   <td>{{Tag("Games")}}</td>
  </tr>
  <tr>
   <td>HTML</td>
   <td>{{Tag("HTML")}}</td>
  </tr>
  <tr>
   <td>HTTP</td>
   <td>{{Tag("HTTP")}}</td>
  </tr>
  <tr>
   <td>JavaScript</td>
   <td>{{Tag("JavaScript")}}</td>
  </tr>
  <tr>
   <td>Marketplace {{Non-standard_Inline}}</td>
   <td>{{Tag("Marketplace")}}</td>
  </tr>
  <tr>
   <td>MathML</td>
   <td>{{Tag("MathML")}}</td>
  </tr>
  <tr>
   <td>Mobile</td>
   <td>{{Tag("Mobile")}}</td>
  </tr>
  <tr>
   <td>Open Web Apps {{Non-standard_Inline}}</td>
   <td>{{Tag("Apps")}}</td>
  </tr>
  <tr>
   <td>SVG</td>
   <td>{{Tag("SVG")}}</td>
  </tr>
  <tr>
   <td>Web Development</td>
   <td>{{Tag("Web Development")}}</td>
  </tr>
  <tr>
   <td>Web Standards</td>
   <td>{{Tag("Web")}}</td>
  </tr>
  <tr>
   <td>WebExtensions</td>
   <td>{{Tag("WebExtensions")}}</td>
  </tr>
  <tr>
   <td>WebGL</td>
   <td>{{Tag("WebGL")}}</td>
  </tr>
  <tr>
   <td>Writing Documentation</td>
   <td>{{Tag("MDN Meta")}}</td>
  </tr>
  <tr>
   <td>XPCOM {{Non-standard_Inline}}</td>
   <td>{{Tag("XPCOM")}}</td>
  </tr>
  <tr>
   <td>XUL {{Non-standard_Inline}}</td>
   <td>{{Tag("XUL")}}</td>
  </tr>
  <tr>
   <th rowspan="3" scope="row" style="vertical-align: baseline; white-space: nowrap;">{{anch("Skill level")}}</th>
   <td>I'm an Expert</td>
   <td>{{Tag("Advanced")}}</td>
  </tr>
  <tr>
   <td>Intermediate</td>
   <td>{{Tag("Intermediate")}}</td>
  </tr>
  <tr>
   <td>I'm Learning</td>
   <td>{{Tag("Beginner")}}</td>
  </tr>
  <tr>
   <th rowspan="7" scope="row" style="vertical-align: baseline; white-space: nowrap;">Document type</th>
   <td>Docs</td>
   <td><em>This restricts the search to docs content, leaving out Hacks and other MDN content.</em></td>
  </tr>
  <tr>
   <td>Demos</td>
   <td><em>This type of document is no longer used on MDN Web Docs.</em></td>
  </tr>
  <tr>
   <td>Tools</td>
   <td>{{Tag("Tools")}}</td>
  </tr>
  <tr>
   <td>Code Samples</td>
   <td>{{Tag("Example")}}</td>
  </tr>
  <tr>
   <td>How-To &amp; Tutorial</td>
   <td>{{Tag("Guide")}}</td>
  </tr>
  <tr>
   <td>Developer Profiles</td>
   <td><em>This includes developer profiles from the MDN site in the search results.</em></td>
  </tr>
  <tr>
   <td>External Resources</td>
   <td><em>The dev team is still figuring this out...</em></td>
  </tr>
 </tbody>
</table>

<h2 id="Tagging_problems_you_can_fix">Tagging problems you can fix</h2>

<p>There are several kinds of tag problems you can help fix:</p>

<dl>
 <dt>No tags</dt>
 <dd>Generally articles should have at <em>least</em> a "{{anch("Document category", "category")}}" tag and a "{{anch("Topic", "topic")}}" tag. Usually other tags are appropriate as well, but if you can help us ensure that the minimum tags are present, you'll be a documentation hero!</dd>
 <dt>Tags that don't follow our tagging standards</dt>
 <dd>Please fix any documents whose tags don't follow the standards on this page.<br>
 Note that you may occasionally see some localized tags (such as <code>Référence</code>) showing up on some English pages. This was due to a <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=776048">bug in Kuma</a>, which caused the tags to reappear even if they were deleted. That bug has <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=776048#c37">since been fixed</a>, so any remaining localized tags can be cleaned up if they're spotted.</dd>
 <dt>Incorrect tags</dt>
 <dd>If you're looking at an article about HTML and it's tagged "JavaScript", that's probably wrong! Likewise, if an article discusses Mozilla internals but has a "Web" tag, that's probably wrong too. Remove these tags and add the right tags if they aren't already there. Please also correct misspelled tags (e.g., "Javascript" will still match, since tags are case-insensitive, but let's not be sloppy!).</dd>
 <dt>Missing tags</dt>
 <dd>If an article has some but not all of the tags it needs, feel free to add more. For example, if a page in JavaScript reference is (correctly) tagged "JavaScript" but nothing else, you're invited to tag the page "Reference" or {{anch("Document category", "another category tag")}} as well!</dd>
 <dt>Tag spam</dt>
 <dd>This insidious beast is the most revolting tag problem of all: some Web vermin has deposited its droppings in the page tags (like "Free warez!" or "Hey I was browsing your site and wanted to ask you if you could help me solve this problem I'm having with Flash crashing all the time"). We've got to delete these right away! They're ugly, they're hard to manage if they're allowed to linger too long, and they're terrible for {{Glossary("SEO")}}.</dd>
</dl>

<p>If you see one (or more) of these problems, please <a href="/en-US/docs/Project:MDN/Contributing/Getting_started#Logging_into_MDN">log into MDN</a> and click EDIT at the top right of the MDN window. Once the editor loads up, scroll down to the bottom of the page, where you'll see the tag box. For more details on the tagging interface, see "<a href="/en-US/docs/MDN/Contribute/Editor/Basics/Tags">The tags box</a>" in the <a href="/en-US/docs/MDN/Contribute/Editor">MDN editor guide</a>.</p>
